class Account < ActiveRecord::Base
  devise :database_authenticatable, :registerable, :recoverable, :rememberable, :trackable, :validatable
  has_one :administrator

  scope :with_admins, -> { joins('left join administrators on accounts.id = administrators.account_id') }
  scope :active, -> { where(on_hold: false) }

  after_create do
    create_administrator if @should_be_admin
  end

  def active_for_authentication?
    super and not self.on_hold?
  end

  # after_create :send_welcome_mail

  # def self.from_omniauth(auth, current_user, ip_address, referrer_id = nil)
  #   authorization = SocialAuthorization.where(:provider => auth.provider, :uid => auth.uid.to_s).first_or_initialize
  #   if authorization.account.blank?
  #     account = current_user.nil? ? Account.where(email: auth["info"]["email"]).first : current_user
  #     if account.blank?
  #       account = Account.new
  #       account.ip_address = ip_address
  #       account.password = @password = Devise.friendly_token[0, 10]
  #       account.email = auth.info.email
  #       account.referrer_id = referrer_id
  #       # account.confirmed_at = Time.now
  #       account.save
  #     end
  #     authorization.username = auth.info.name
  #     authorization.account = account
  #     authorization.save
  #   end
  #   authorization.account
  # end

  def caption
    email
  end

  # def send_welcome_mail
  #   if current_sign_in_ip.present?
  #     Thread.new do
  #       FrontMailer.welcome(self).deliver_now
  #     end
  #   end
  # end

  def admin
    administrator.present?
  end

  def admin=(value)
    if value.to_i > 0
      if new_record?
        @should_be_admin = true
      else
        create_administrator if administrator.nil?
      end
    else
      administrator.destroy if administrator.present?
    end
  end

end
