class BlockVersion < ActiveRecord::Base
  has_many :blocks, dependent: :destroy
  belongs_to :account, class_name: Rails.configuration.x.active_translation.admin_class_name || 'Account'
  validates :account, presence: true

  scope :active, -> { where(active: true) }
  scope :inactive, -> { where(active: [false, nil]) }
  scope :by_admin, -> (admin) { where(account: admin) }

  def activate
    update_attributes(active: true)
  end
end
